<?php

/*
 * @file Tache.class.php
 *
 * This file is part of OpenXum server
 *
 * Copyright (c) 2011-2012 Clément Vanvincq <cvanvincq@users.sourceforge.net>
 *
 * See the AUTHORS or Authors.txt file for copyright owners and contributors
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

	class Tache{
		/* Attributs */
		var $lettre_tache;
		var $description;
		var $predecesseurs;
		var $successeurs;
		var $datePlusTot;
		var $datePlusTard;
		var $finPlusTot;
		var $finPlusTard;
		var $marge;
		var $duree;
		
		/* Compteurs */
		protected static $compteurSucc = 0;
		protected static $compteurPred = 0;
		
		function __construct($lettre_tache = null, $description = null, $duree = 0, $datePlusTot = 0, $datePlusTard = 0, $finPlusTot = 0, $finPlusTard = 0){
			$this->lettre_tache = $lettre_tache;
			$this->description = $description;
			$this->duree = $duree;
			$this->datePlusTot = $datePlusTot;
			$this->datePlusTard = $datePlusTard;
			$this->finPlusTot = $finPlusTot;
			$this->finPlusTard = $finPlusTard;
			$this->marge = 0;
			
			$this->predecesseurs = null;
			$this->successeurs = null;
		}
		
		function addPredecesseur($tache){
			$this->predecesseurs[self::$compteurPred++] = $tache;
		}
		
		function addSuccesseur($tache){
			$this->successeurs[self::$compteurSucc++] = $tache;
		}
		
		function calculDatePlusTot(){
			if(empty($this->predecesseurs))
				$this->datePlusTot = 0;
			else{
				/* Initialisation du maximum */
				$max = 0;
				
				foreach($this->predecesseurs as $value){
					if($value->finPlusTot > $max)
						$max = $value->finPlusTot;
				}
				/* Affectation */
				$this->datePlusTot = $max;
			}
		}
		
		function calculFinPlusTot(){
			$this->finPlusTot = $this->datePlusTot + $this->duree;
		}
		
		function calculFinPlusTard(){
			if(empty($this->successeurs))
				$this->finPlusTard = $this->finPlusTot;
			else{
				/* Initialisation du minimum */
				$min = 999;
				
				foreach($this->successeurs as $value){
					if($value->datePlusTard < $min)
						$min = $value->finPlusTot - $value->duree;
				}
				/* Affectation */
				$this->finPlusTard = $min;
			}			
		}
		
		function calculDateplusTard(){
			$this->datePlusTard = $this->finPlusTard - $this->duree;
		}
		
		function calculMarge(){
			$this->marge = $this->finPlusTard - $this->finPlusTot;
		}
		
		function display(){
			echo "Tache : ".$this->lettre_tache."<br/>";
			echo "Description : ".$this->description."<br/>";
			echo "Duree : ".$this->duree."<br/>";
			echo "datePlusTot : ".$this->datePlusTot."<br/>";
			echo "datePlusTard : ".$this->datePlusTard."<br/>";
			echo "finPlusTot : ".$this->finPlusTot."<br/>";
			echo "finPlusTard : ".$this->finPlusTard."<br/>";
			echo "marge : ".$this->marge."<br/>";
			echo "<br/>";
		}
	}
