<?php
	include("header.php");
	
	/* Initialisation de la variable */
	$LOC = "";
	
	/* Récupération du nombre de LOC associé au projet courant */
	if(isset($_SESSION) && !empty($_SESSION)){
		$temp =& getLocById($db, $_SESSION['id_projet']);
		
		/* Uniquement si la méthode points de fonction a déjà été renseignée */
		if(!empty($temp->LOC))
			/* Conversion LOC vers KLOC */
			$LOC = $temp->LOC / 1000;
	}
	
	/* Chargement des facteurs de COCOMO pour les calculs à venir */
	if(!empty($_GET) && isset($_GET['methode'])){
		$facteurs =& getCocomoFactorsByType($db, utf8_decode($_GET['methode']));
		
		/* Conversion PHP -> Javascript */
		echo '<script type="text/javascript">';
			echo 'var vfacteursEffort = new Array( "'.$facteurs['effort']['organique']['a'].'", 
													  			"'.$facteurs['effort']['organique']['b'].'",
													  			"'.$facteurs['effort']['semi-détaché']['a'].'",
													 			"'.$facteurs['effort']['semi-détaché']['b'].'",
													  			"'.$facteurs['effort']['embarqué']['a'].'",
													  			"'.$facteurs['effort']['embarqué']['b'].'" );';
													  			 			
			echo 'var vfacteursTempsDev = new Array( "'.$facteurs['temps développement']['organique']['a'].'", 
													  			  "'.$facteurs['temps développement']['organique']['b'].'",
													  			  "'.$facteurs['temps développement']['semi-détaché']['a'].'",
													 			  "'.$facteurs['temps développement']['semi-détaché']['b'].'",
													  			  "'.$facteurs['temps développement']['embarqué']['a'].'",
													  			  "'.$facteurs['temps développement']['embarqué']['b'].'" );';
		echo '</script>';	
	}
		
?>

<div id="content">
	<div id="content-left">
		<div id="pkglist-search">
			<div id="intro" class="box">
				<h2>Méthode COCOMO</h2>
				<h4>Rappel :</h4>
				<p>COCOMO (acronyme de l'anglais COnstructive COst MOdel) est un modèle permettant de définir une estimation de l'effort à
				fournir dans un développement logiciel et la durée que ce dernier prendra en fonction des ressources allouées.
				Le résultat de ce modèle n'est qu'une estimation, il n'est en rien infaillible et parfaitement exact.</p>
			</div>
			
			<table>
				<tr>
					<td class="center"><a href="./cocomo.php?methode=base"><img src="./images/archlinux-icon.png" alt="base" ></a></td>
					<td class="center"><a href="./cocomo.php?methode=intermédiaire"><img src="./images/archlinux-icon.png" alt="intermediaire" ></a></td>
				</tr>
				<tr>
					<td class="center"><label>COCOMO de base</label></td>
					<td class="center"><label>COCOMO intermédiaire</label></td>
				</tr>
			</table>
			
			<br/>
			<br/>
			
			<div id="news">
			
			<?php
				if(!empty($_GET) && $_GET['methode'] == "base"){
						echo '<h3>COCOMO de base</h3>';
						echo '<br/>';
						
						echo '<form name="cocomobase">';
							echo '<label>Nombre de KLOC</label>';
							echo '<input type="text" value="'.$LOC.'" name="KLOC" />';
						echo '</form>';
						
						echo '<br/>';
						
						echo '<table class="results" style="width:500px;">';
							echo '<tr class="even">';
								echo '<td><label>Mode</label></td>';
								echo '<td><label id="mode"></label></td>';
							echo '</tr>';
							echo '<tr class="odd">';
								echo '<td><label>Effort</label></td>';
								echo '<td><label id="effort"></label></td>';
							echo '</tr>';
							echo '<tr class="even">';
								echo '<td><label>Temps de développement</label></td>';
								echo '<td><label id="temps_dev"></label></td>';
							echo '</tr>';
							echo '<tr class="odd">';
								echo '<td><label>Taille de l\'équipe</label></td>';
								echo '<td><label id="taille_equipe"></label></td>';
							echo '</tr>';
							echo '<tr class="">';
								echo '<td><button onClick="javascript:calculerCocomoBase(document.cocomobase);">Calculer</button></td>';
								echo '<td><span id="submit"></span></td>';
							echo '</tr>';
						echo '</table>';
				}
				elseif(!empty($_GET) && $_GET['methode'] == "intermédiaire"){
						$param = "<input type='text' / size='8'>";
					
						echo '<h3>COCOMO intermédiaire</h3>';
						echo '<br/>';
						
						echo '<form name="cocomointermediaire">';
									echo '<label>Nombre de KLOC</label>';
									echo '<input type="text" value="'.$LOC.'" name="KLOC" />';
						echo '</form>';
						
						echo '<br/>';
						
						echo '<form name="complexites">';
							echo '<table class="results">';
							echo '<caption><h4>Tableau des compléxités</h4></caption>';
								echo '<tr>';
									echo '<td>RELY - Niveau de disponibilité</td>';
									echo '<td>'.$param.'</td>';
								echo '</tr>';
								echo '<tr>';
									echo '<td>DATA - Taille base de données</td>';
									echo '<td>'.$param.'</td>';
								echo '</tr>';
								echo '<tr>';
									echo '<td>CPLX - Complexité fonctionnelle</td>';
									echo '<td>'.$param.'</td>';
								echo '</tr>';
								echo '<tr>';
									echo '<td>TIME - Temps de réponse requis</td>';
									echo '<td>'.$param.'</td>';
								echo '</tr>';
								echo '<tr>';
									echo '<td>STOR - Répartition des données</td>';
									echo '<td>'.$param.'</td>';
								echo '</tr>';
								echo '<tr>';
									echo '<td>VIRT - Stabilité des choix techniques</td>';
									echo '<td>'.$param.'</td>';
								echo '</tr>';
								echo '<tr>';
									echo '<td>TURN - Disponibilité de la plate-forme</td>';
									echo '<td>'.$param.'</td>';
								echo '</tr>';
								echo '<tr>';
									echo '<td>ACAP - Expérience des analyses</td>';
									echo '<td>'.$param.'</td>';
								echo '</tr>';
								echo '<tr>';
									echo '<td>AEXP - Connaissance domaine fonctionnel</td>';
									echo '<td>'.$param.'</td>';
								echo '</tr>';
								echo '<tr>';
									echo '<td>PCAP - Expérience des programmeurs</td>';
									echo '<td>'.$param.'</td>';
								echo '</tr>';
								echo '<tr>';
									echo '<td>VEXP - Connaissance (SGBD, OS)</td>';
									echo '<td>'.$param.'</td>';
								echo '</tr>';	
								echo '<tr>';
									echo '<td>LEXP - Connaissance langage programmation</td>';
									echo '<td>'.$param.'</td>';
								echo '</tr>';	
								echo '<tr>';
									echo '<td>MOOP - Pratique moderne de programmation</td>';
									echo '<td>'.$param.'</td>';
								echo '</tr>';	
								echo '<tr>';
									echo '<td>TOOL - Utilisation d\'outils (AGL)</td>';
									echo '<td>'.$param.'</td>';
								echo '</tr>';	
								echo '<tr>';
									echo '<td>SCED - Rigidité du planning (délais)</td>';
									echo '<td>'.$param.'</td>';
								echo '</tr>';														
							echo '</table>';
						echo '</form>';
						
						echo '<br/><br/>';
						
						echo '<table class="results" style="width:500px;">';
							echo '<tr class="even">';
								echo '<td><label>Mode</label></td>';
								echo '<td><label id="mode"></label></td>';
							echo '</tr>';
							echo '<tr class="odd">';
								echo '<td><label>Effort</label></td>';
								echo '<td><label id="effort"></label></td>';
							echo '</tr>';
							echo '<tr class="even">';
								echo '<td><label>Temps de développement</label></td>';
								echo '<td><label id="temps_dev"></label></td>';
							echo '</tr>';
							echo '<tr class="odd">';
								echo '<td><label>Taille de l\'équipe</label></td>';
								echo '<td><label id="taille_equipe"></label></td>';
							echo '</tr>';
							echo '<tr class="">';
								echo '<td><button onClick="javascript:calculerCocomoIntermediaire(document.cocomointermediaire, document.complexites);">Calculer</button></td>';
								echo '<td><span id="submit"></span></td>';
							echo '</tr>';
						echo '</table>';
				}
			?>
			
			<form name="resultat" method="POST" action="./metier/metier.php?action=cocomo">
				<input type="hidden" name="effort" />
				<input type="hidden" name="temps_dev" />
				<input type="hidden" name="taille_equipe" />
				<input type="hidden" name="type_cocomo" />
				<input type="hidden" name="mode" />
				<input type="hidden" name="kloc" />
			</form>
			
			</div>		
		</div>
	</div>
	
	<?php include("rightmenu.php"); ?>	
	
</div>

<?php
	include("footer.php");
?>
