﻿function initSelectList(formulaire, position){
	// Déclaration des variables utilisées
	var vselect;
	var vlettre;
	var code = "<option value=''></option>";
	
	// On parcours le formulaire PERT (on commence à 4 car on s'en tape du libelle et du nombre de tache)
	for(var i = 4 ; i < (position * 4) + 4 ; i++){
		// Si i est divisible par 4
		if(i%4 == 0 && i != 0){
			// Affectation des valeurs
			vselect = (i / 4);
			vlettre = (i - 4) + 4;
				
			// Génération du code
			code += "<option name='option"+i+"' value='"+formulaire.elements[vlettre].value+"'>&nbsp;&nbsp;"+formulaire.elements[vlettre].value+"&nbsp;&nbsp;</option>";
			// Injection du code
			document.getElementById('selectOption'+vselect).innerHTML = code;	
		}
	}
}

function addTask(nbTache){
	// Génération du code à injecter
	var code = "<caption><h4>Liste des tâches</h4></caption>";
				code += "<tr class='even'>";
					code += "<td><label>Tâche</label></td>";
					code += "<td><label>Description</label></td>";
					code += "<td><label>Prédécesseur</label></td>";
					code += "<td><label>Durée (en jours)</label></td>";
				code += "</tr>";
	
	for(var i = 0 ; i < nbTache ; i++){
		code += "<tr class=''>";
		code += "<td><input onChange='javascript:initSelectList(document.pert, "+i+")' size='3' maxlength='2' type='text' name='tache"+i+"' /></td>";
		code += "<td><input size='40' maxlength='50' type='text' name='description"+i+"' /></td>";
		code += "<td><select name='predecesseur"+i+"[]' size='3' id='selectOption"+i+"' multiple='multiple'>";
		code += "<option></option>";
		code += "</select></td>";
		code += "<td><input type='text' size='6' maxlength='5' name='duree"+i+"' /></td>";
		code += "</tr>";
	}
	// Injection du code
	document.getElementById('aim').innerHTML = code;
	
	// Ajout du bouton de validation
	document.getElementById('button').innerHTML = "<button onClick='javascript:this.submit();'>Calculer</button>";
}

function checkForm(formulaire){
		var vreturn = true;	
	
		for(var i = 0 ; i < formulaire.length ; i++){
			if(formulaire.elements[i].value == '')
			vreturn = false;
			break;
		}
			
		return vreturn;
}

function calculerPointsFonction(complexite, couts, entree, equivalence){
	var TCF 	= 0;
	var UFC 	= 0;
	var PF 	= 0;
	var LOC 	= 0;
	var coeff = new Array();
	
	/* Calcul du TCF */
	for(var i = 0 ; i < couts.length ; i++){
		TCF += couts.elements[i].value * 1;
	}
	
	/* Calcul du UFC */
	for(var i = 0 ; i < complexite.length ; i++){
		UFC += complexite.elements[i].value * entree.elements[i].value * 1;
	}
	
	/* Calcul du PF */
	TCF = (TCF == 0) ? 1 : TCF;
	PF = TCF * UFC * 1;
	
	/* Estimation du nombre de LOC */
	for(var i = 0 ; i < equivalence.length ; i++)
		coeff[i] = (equivalence.elements[i].value == 0) ? 1 : equivalence.elements[i].value;
	
	/* Calcul bourrin.. optimisation prévue à l'occasion */
	LOC = (complexite.elements[0].value * entree.elements[0].value +
			 complexite.elements[1].value * entree.elements[1].value +
			 complexite.elements[2].value * entree.elements[2].value) * coeff[0] +
			(complexite.elements[3].value * entree.elements[3].value +
			 complexite.elements[4].value * entree.elements[4].value +
			 complexite.elements[5].value * entree.elements[5].value) * coeff[1] +
			(complexite.elements[6].value * entree.elements[6].value +
			 complexite.elements[7].value * entree.elements[7].value +
			 complexite.elements[8].value * entree.elements[8].value) * coeff[2] +
			(complexite.elements[9].value * entree.elements[9].value +
			 complexite.elements[10].value * entree.elements[10].value +
			 complexite.elements[11].value * entree.elements[11].value) * coeff[3] +
			(complexite.elements[12].value * entree.elements[12].value +
			 complexite.elements[13].value * entree.elements[13].value +
			 complexite.elements[14].value * entree.elements[14].value) * coeff[4];
	
	/* Multiplication par le TCF pour obtenir le vrai coût en LOC */
	LOC *= TCF;
	
	/* Affichage des résultats */
	document.resultat.UFC.value = UFC;
	document.resultat.TCF.value = TCF;
	document.resultat.PF.value = PF;
	document.resultat.LOC.value = LOC;
	
	document.getElementById('UFC').innerHTML = '<label>'+UFC+'</label>';
	document.getElementById('TCF').innerHTML = '<label>'+TCF+'</label>';
	document.getElementById('PF').innerHTML = '<label>'+PF+'</label>';
	document.getElementById('LOC').innerHTML = '<label>'+LOC+'</label>';
	
	/* Affichage du bouton valider */
	document.getElementById('submit').innerHTML = '<button onClick="javascript:document.resultat.submit();">Enregistrer</button>';
}

function calculerCocomoBase(cocomobase){
	var effort = 0;
	var temps_dev = 0;
	var taille_equipe = 0;
	var mode = "";
	
	/* Déduction du mode à employer */
	/* Rappel : loc < 50000 Mode organique */
	/*				50000 <= loc < 300000 Mode semi-détaché */
	/* 			loc > 300000 Mode embarqué */
	if(cocomobase.KLOC.value < 50){
		/* Valeur des coefficients mode organique */
		Aeff = vfacteursEffort[0];		Atdev = vfacteursTempsDev[0];
		Beff = vfacteursEffort[1];		Btdev = vfacteursTempsDev[1];
		
		mode = "Organique";
	}
	else if(cocomobase.KLOC.value < 300){
		/* Valeur des coefficients mode semi-détaché */
		Aeff = vfacteursEffort[2];		Atdev = vfacteursTempsDev[2];
		Beff = vfacteursEffort[3];		Btdev = vfacteursTempsDev[3];
		
		mode = "Semi-détaché";
	}
	else{
		/* Valeur des coefficients mode embarqué */
		Aeff = vfacteursEffort[4];		Atdev = vfacteursTempsDev[4];
		Beff = vfacteursEffort[5];		Btdev = vfacteursTempsDev[5];
		
		mode = "Embarqué";		
	}
	/* Calcul de l'effort */
	effort = Aeff * Math.pow(cocomobase.KLOC.value, Beff);
	/* Calcul du temps de développement */
	temps_dev = Atdev * Math.pow(effort, Btdev);
	/* Calcul de la taille de l'équipe */
	taille_equipe = effort / temps_dev;
	
	/* Affichage des résultats */
	document.resultat.effort.value = effort;
	document.resultat.temps_dev.value = temps_dev;
	document.resultat.taille_equipe.value = taille_equipe;
	document.resultat.type_cocomo.value = "COCOMO de base";
	document.resultat.mode.value = mode;
	document.resultat.kloc.value = cocomobase.KLOC.value;
	
	document.getElementById('mode').innerHTML = '<label>'+mode+'</label>';
	document.getElementById('effort').innerHTML = '<label>'+effort+'</label>'
	document.getElementById('temps_dev').innerHTML = '<label>'+temps_dev+'</label>'
	document.getElementById('taille_equipe').innerHTML = '<label>'+taille_equipe+'</label>'
	
	/* Affichage du bouton enregistrer */
	document.getElementById('submit').innerHTML = '<button onClick="javascript:document.resultat.submit();">Enregistrer</button>';
}

function calculerCocomoIntermediaire(cocomoIntermediaire, complexites){
	var effort = 0;
	var temps_dev = 0;
	var taille_equipe = 0;
	var mode = "";
	var Fcomplexite = 1;
	
	/* Déduction du mode à employer */
	/* Rappel : loc < 50000 Mode organique */
	/*				50000 <= loc < 300000 Mode semi-détaché */
	/* 			loc > 300000 Mode embarqué */
	if(cocomoIntermediaire.KLOC.value < 50){
		/* Valeur des coefficients mode organique */
		Aeff = vfacteursEffort[0];		Atdev = vfacteursTempsDev[0];
		Beff = vfacteursEffort[1];		Btdev = vfacteursTempsDev[1];
		
		mode = "Organique";
	}
	else if(cocomoIntermediaire.KLOC.value < 300){
		/* Valeur des coefficients mode semi-détaché */
		Aeff = vfacteursEffort[2];		Atdev = vfacteursTempsDev[2];
		Beff = vfacteursEffort[3];		Btdev = vfacteursTempsDev[3];
		
		mode = "Semi-détaché";
	}
	else{
		/* Valeur des coefficients mode embarqué */
		Aeff = vfacteursEffort[4];		Atdev = vfacteursTempsDev[4];
		Beff = vfacteursEffort[5];		Btdev = vfacteursTempsDev[5];
		
		mode = "Embarqué";		
	}
	
	/* Calcul de facteur de complexité */
	for(i = 0 ; i < complexites.length ; i++){
		if(complexites.elements[i].value != 0)
			Fcomplexite *= complexites.elements[i].value * 1;
	}
	/* Rectification en cas de valeur nulle */	
	Fcomplexite = (Fcomplexite == 0) ? 1 : Fcomplexite;
	
	/* Calcul de l'effort */
	effort = Aeff * Math.pow(cocomoIntermediaire.KLOC.value, Beff) * Fcomplexite;
	/* Calcul du temps de développement */
	temps_dev = Atdev * Math.pow(effort, Btdev);
	/* Calcul de la taille de l'équipe */
	taille_equipe = effort / temps_dev;
	
	/* Affichage des résultats */
	document.resultat.effort.value = effort;
	document.resultat.temps_dev.value = temps_dev;
	document.resultat.taille_equipe.value = taille_equipe;
	document.resultat.type_cocomo.value = "COCOMO intermédiaire";
	document.resultat.mode.value = mode;
	document.resultat.kloc.value = cocomointermediaire.KLOC.value;
	
	document.getElementById('mode').innerHTML = '<label>'+mode+'</label>';
	document.getElementById('effort').innerHTML = '<label>'+effort+'</label>'
	document.getElementById('temps_dev').innerHTML = '<label>'+temps_dev+'</label>'
	document.getElementById('taille_equipe').innerHTML = '<label>'+taille_equipe+'</label>'
	
	/* Affichage du bouton enregistrer */
	document.getElementById('submit').innerHTML = '<button onClick="javascript:document.resultat.submit();">Enregistrer</button>';	
}

