<?php
	/* Démarrage de la session */
	session_start();
	/* Importation des fichiers de définition */
	include_once("../inc/config.inc.php");
	require_once("../class/Database.class.php");
	/* PERT */
	require_once("../class/Tache.class.php");
	/* Création d'une instance de connexion */
	$db = new Database(USER, PASSWORD, DATABASE, SERVER);

	switch($_GET['action']) {
		/*==============================*/
		/* Création d'un nouveau projet */
		/*==============================*/
		case 'newproject':
			/* Récupération des données du formulaire */
			$libelle_projet = $_POST['libelle_projet'];
			/* Préparation de la requête SQL */	
			$query = "INSERT INTO Projet(libelle_projet) ".
						"VALUES('".utf8_decode($libelle_projet)."')";		
			/* Exécution */
			$db->execQuery($query);
			/* Affectations à la variable de session */
			$_SESSION['libelle_projet'] = $libelle_projet;
			$_SESSION['id_projet'] = $db->lastId();
			
			/* Redirection */
			$message = urlencode("Le projet a été créé avec succès.");
			header('location:../viewproject.php?id_projet='.$db->lastId().'&message='.$message);
		break;
		/*============*/
		/* Fin action */
		/*============*/
		

		/*============================*/
		/*  Chargement de la session  */
		/*============================*/
		case 'session-login':
			$_SESSION['id_projet'] = $_GET['id_projet'];
			$_SESSION['libelle_projet'] = $_GET['libelle_projet'];
			
			/* Redirection */
			$message = urlencode("Le projet a été chargé en session.");
			header('location:../viewproject.php?id_projet='.$_GET['id_projet'].'&message='.$message);
		break;
		/*===================*/
		/* Fin session-login */
		/*===================*/		
		
		
		/*=============================*/
		/*  Destruction de la session  */
		/*=============================*/
		case 'session-logout':
			unset($_SESSION);
			session_destroy();
			
			/* Redirection */
			$message = urlencode("Le projet n'est plus actif en session.");
			header('location:../index.php?message='.$message);
		break;
		/*====================*/
		/* Fin session-logout */
		/*====================*/


		/*=========================================*/
		/*  Enregistrement des Points de fonction  */
		/*=========================================*/
		case 'points-fonction':
			/* Si un projet est actif dans la session */
			if(isset($_SESSION) && !empty($_SESSION)){
				
				/* Vérification s'il n'existe pas déjà des points de fonction associé au projet */
				$query = "SELECT id_pointsfonction ".
							"FROM Projet ".
							"WHERE id_projet=".$_SESSION['id_projet'];
				/* Exécution */			
				$result = $db->execQuery($query);			
				/* Récupération du tuple */
				$row = $db->nextRow($result);
				
				/* Si aucun point de fonction n'est déjà associé au projet courant */
				if($row[0] == 0){
					/* Insertion des données dans la table Points de fonction */
					$query = "INSERT INTO Pointsfonction(UFC, TCF, PF, LOC) ".
								"VALUES(".$_POST['UFC'].", ".$_POST['TCF'].", ".$_POST['PF'].", ".$_POST['LOC'].")";
					/* Exécution */
					$db->execQuery($query);
					
					/* Mise à jour de la table Projet */
					$query = "UPDATE Projet ".
								"SET id_pointsfonction=".$db->lastId()." ".
								"WHERE id_projet=".$_SESSION['id_projet']."";
					/* Exécution */
					$db->execQuery($query);
				}
				/* Sinon, on met à jour le tuple */
				else{
					$query = "UPDATE Pointsfonction ".
								"SET UFC=".$_POST['UFC'].", TCF=".$_POST['TCF'].", PF=".$_POST['PF'].", LOC=".$_POST['LOC']." ".
								"WHERE id_pointsfonction=".$row[0];
					/* Exécution */
					$db->execQuery($query);				
				}
				
				$message = urlencode("Enregistrement des points de fonction effectué.");
			}
			else
				$message = urlencode("Aucune donnée n'a été enregistré.");
			
			/* Redirection */
			header('location:../index.php?message='.$message);
			
		break;
		/*=====================*/
		/* Fin points-fonction */
		/*=====================*/		
		
		
		/*============================*/
		/*  Enregistrement du COCOMO  */
		/*============================*/
		case 'cocomo':
			/* Si un projet est actif dans la session */
			if(isset($_SESSION) && !empty($_SESSION)){
				
				/* Vérification s'il n'existe pas déjà un COCOMO associé au projet courant */
				$query = "SELECT id_cocomo ".
							"FROM Projet ".
							"WHERE id_projet=".$_SESSION['id_projet'];
				/* Exécution */			
				$result = $db->execQuery($query);			
				/* Récupération du tuple */
				$row = $db->nextRow($result);	
				
				/* Si aucun COCOMO n'est associé au projet */
				if($row[0] == 0){
					/* insertion des données dans la table Cocomo */
					$query = "INSERT INTO Cocomo(type_cocomo, mode_cocomo, kloc, effort, temps_dev, taille_equipe) ".
								"VALUES('".utf8_decode($_POST['type_cocomo'])."', '".utf8_decode($_POST['mode'])."', ".$_POST['kloc'].", ".$_POST['effort'].", ".$_POST['temps_dev'].", ".$_POST['taille_equipe'].")";
					/* Exécution */
					$db->execQuery($query);
					
					/* Mise à jour de la table Projet */
					$query = "UPDATE Projet ".
								"SET id_cocomo=".$db->lastId()." ".
								"WHERE id_projet=".$_SESSION['id_projet']."";
					/* Exécution */
					$db->execQuery($query);	
				}
				/* Sinon, on met à jour le tuple associé */
				else{
					$query = "UPDATE Cocomo ".
								"SET type_cocomo='".utf8_decode($_POST['type_cocomo'])."', mode_cocomo='".utf8_decode($_POST['mode'])."', kloc=".$_POST['kloc'].", temps_dev=".$_POST['temps_dev'].", taille_equipe=".$_POST['taille_equipe']." ".
								"WHERE id_cocomo=".$row[0];
					/* Exécution */
					$db->execQuery($query);
				}

				$message = urlencode("Enregistrement du Cocomo effectué.");
			}
			else
				$message = urlencode("Aucune donnée n'a été enregistré.");
			
			/* Redirection */
			header('location:../index.php?message='.$message);		
			
		break;
		/*============*/
		/* Fin cocomo */
		/*============*/
		
		
		/*==================================*/
		/*  Enregistrement facteurs COCOMO  */
		/*==================================*/
		case 'facteurscocomo':
			/* On parcours le tableau des facteurs de coût COCOMo */
			for($i = 1 ; $i < (Count($_POST) / 2) + 1 ; $i++){
				$a = $i."a";
				$b = $i."b";
				
				/* Construction de la requête */
				$query = "UPDATE FacteursCocomo ".
							"SET a=".$_POST[$a].", b=".$_POST[$b]." ".
							"WHERE id_facteurscocomo=".$i."";
				/* Execution de la requête */
				$db->execQuery($query);
			}

			/* Redirection */
			$message = urlencode("Mise à jour des facteurs Cocomo effectuée.");
			header('location:../index.php?message='.$message);
		
		break;
		/*====================*/
		/* Fin facteurscocomo */
		/*====================*/


		/*==================================*/
		/*  Suppression d'un projet courant */
		/*==================================*/
		case 'supprimer-projet';
			/* Récupération des données */
			if(isset($_GET) && !empty($_GET['id_projet'])){
				/* Supression Pointsfonction */
				$query = "DELETE FROM Pointsfonction ".
							"WHERE id_pointsfonction in ".
																	 "(SELECT id_pointsfonction ".
																	 "FROM Projet ".
																	 "WHERE id_projet=".$_GET['id_projet'].")";
				/* Execution de la requête */
				$db->execQuery($query);
				/* Supression Cocomo */
				$query =	"DELETE FROM Cocomo ".
							"WHERE id_cocomo in ".
													  "(SELECT id_cocomo ".
													  "FROM Projet ".
													  "WHERE id_projet=".$_GET['id_projet'].")";
				/* Execution de la requête */
				$db->execQuery($query);
				
				/* Suppression diagramme PERT */
				// Récupération de l'identifiant pert
				$query = "SELECT id_pert ".
							"FROM Projet ".
							"WHERE id_projet=".$_GET['id_projet'];
				/* Execution */
				$result = $db->execQuery($query);			
				$row = $db->nextObject($result);
				
				/* Suppression Pert */
				$query = "DELETE FROM Pert ".
							"WHERE id_pert=".$row->id_pert;
				$db->execQuery($query);
				/* Suppression tâche */
				$query = "DELETE FROM Tache ".
							"WHERE id_pert=".$row->id_pert;
				$db->execQuery($query);				
				
				/* Supression Projet */
				$query = "DELETE FROM Projet WHERE id_projet=".$_GET['id_projet']."";
				/* Execution de la requête */
				$db->execQuery($query);
			}
			
			/* Si le projet supprimmé est encore en session, on détruit icelle */
			if(isset($_SESSION) && $_SESSION['id_projet'] == $_GET['id_projet']){
				unset($_SESSION);
				session_destroy();				
			}
			
			/* Redirection */
			$message = urlencode("Le projet a été supprimé avec succès.");
			header('location:../index.php?message='.$message);
			
		break;
		/*======================*/
		/* Fin supprimer-projet */
		/*======================*/
		

		/*======================================*/
		/* Création d'un nouveau diagramme PERT */
		/*======================================*/
		case 'save-pert':
			/*=========================================*/
			/* Première étape : calcul des marges etc. */
			/*=========================================*/
			
			/* Création des tâches */
			for($i = 0 ; $i < $_POST['nombreTache'] ; $i++){
				
				$tache[$i] = new Tache($_POST['tache'.$i], $_POST['description'.$i], $_POST['duree'.$i]);
				
				/* Ajout des prédécesseurs s'il y en a */
				if(isset($_POST['predecesseur'.$i]) && !empty($_POST['predecesseur'.$i]))
					foreach($_POST['predecesseur'.$i] as $value)
						for($j = 0 ; $j < $_POST['nombreTache'] ; $j++)
							if($_POST['tache'.$j] == $value)
								$tache[$i]->addPredecesseur($tache[$j]);
					
				/* Lancement de la première série de calculs */	
				$tache[$i]->calculDatePlusTot();
				$tache[$i]->calculFinPlusTot();
			}
			
			/* Ajout des successeurs s'il y en a */
			for($i = 0 ; $i < $_POST['nombreTache'] ; $i++){
				/* Parcours de toutes les tâches suivants la tâche courante */
				for($j = $i+1 ; $j < $_POST['nombreTache'] ; $j++){
					/* Si la tâche suivant la courante comporte des prédécesseurs */
					if(isset($tache[$j]->predecesseurs) && !empty($tache[$j]->predecesseurs)){
						/* Pour chaque prédécesseurs */
						foreach($tache[$j]->predecesseurs as $value){
							/* Si le prédécesseur d'une tâche suivante vaut la valeur de la tache courante */
							if($value->lettre_tache == $tache[$i]->lettre_tache){
								/* Ajout comme successeur */
								$tache[$i]->addSuccesseur($tache[$j]);
							}
						}
					}
				}
				
				/* Lancement de la deuxième série de calculs */	
				$tache[$i]->calculFinPlusTard();
				$tache[$i]->calculDateplusTard();
				$tache[$i]->calculMarge();
			}		
		
			/*================================*/
			/* Deuxième étape : insertion SQL */
			/*================================*/

			/* Vérification si un projet est chargé en session */
			if(isset($_SESSION) && !empty($_SESSION)){
				
				/* Vérification s'il n'existe pas déjà un diagramme PERT associé au projet */
				$query = "SELECT id_pert ".
							"FROM Projet ".
							"WHERE id_projet=".$_SESSION['id_projet'];
				/* Exécution */			
				$result = $db->execQuery($query);			
				/* Récupération du tuple */
				$row = $db->nextRow($result);
				
				/* Si aucun diagramme Pert n'est associé au projet */
				if($row[0] == 0){
					
					/* Honte à moi !!! */
					marqueur:
					
					/* Création du nouveau diagramme PERT */
					$query = "INSERT INTO Pert(libelle_pert) ".
								"VALUES('".utf8_decode($_POST['libelle_pert'])."')";
					/* Exécution de la requête */
					$db->execQuery($query);
					
					/* Récupération de l'identifiant du diagramme PERT */
					$id_pert = $db->lastId();
					
					/* Mise à jour de la table projet */
					$query = "UPDATE Projet ".
								"SET id_pert=".$id_pert." ".
								"WHERE id_projet=".$_SESSION['id_projet'];
					/* Exécution de la requête */
					$db->execQuery($query);
					
					for($i = 0 ; $i < $_POST['nombreTache'] ; $i++){
						/* Si la tâche courante a des prédécesseurs */
						if(isset($_POST['predecesseur'.$i]) && !empty($_POST['predecesseur'.$i])){
							/* Initialisation */
							$predecesseurs = "";
							
							/* Génération des prédécesseurs */
							foreach($_POST['predecesseur'.$i] as $value){
								$predecesseurs .= $value.":";
							}
							
							/* Création de la tâche (avec prédécesseur) */
							$query = "INSERT INTO Tache(lettre_tache, libelle_tache, duree, predecesseur, datePlusTot, datePlusTard, finPlusTot, finPlusTard, marge, id_pert) ".
										"VALUES('".$_POST['tache'.$i]."', '".utf8_decode($_POST['description'.$i])."', '".$_POST['duree'.$i]."', '".$predecesseurs."', ".$tache[$i]->datePlusTot.", ".$tache[$i]->datePlusTard.", ".$tache[$i]->finPlusTot.", ".$tache[$i]->finPlusTard.", ".$tache[$i]->marge.", ".$id_pert.")";
						}
						else{
							/* Création de la tâche (sans prédécesseur) */
							$query = "INSERT INTO Tache(lettre_tache, libelle_tache, duree, datePlusTot, datePlusTard, finPlusTot, finPlusTard, marge, id_pert) ".
										"VALUES('".$_POST['tache'.$i]."', '".utf8_decode($_POST['description'.$i])."', '".$_POST['duree'.$i]."', ".$tache[$i]->datePlusTot.", ".$tache[$i]->datePlusTard.", ".$tache[$i]->finPlusTot.", ".$tache[$i]->finPlusTard.", ".$tache[$i]->marge.", ".$id_pert.")";
						}		
						
						/* Exécution de la requête */
						$db->execQuery($query);
						/* Récupération des identifiants des tâches générés */
						$id_tache[$i] = $db->lastId();
					}
					
					/* Insertion des tâche dans le diagramme PERT */
					foreach($id_tache as $value){
						$query = "INSERT INTO Pert(id_pert, libelle_pert, id_tache) ".
									"VALUES(".$id_pert.", '".utf8_decode($_POST['libelle_pert'])."', ".$value.")";
						/* Exécution de la requête */
						$db->execQuery($query);
					}
					
					/* Suppression des mauvais tuples */
					$query = "DELETE FROM Pert ".
								"WHERE id_tache=0";
					/* Exécution de la requête */
					$db->execQuery($query);
				}
				/* Si un diagramme Pert est déjà associé au projet */
				else{
					/* On supprime l'existant */
					$query = "SELECT id_pert ".
								"FROM Projet ".
								"WHERE id_projet=".$_SESSION['id_projet'];
					/* Execution */
					$result = $db->execQuery($query);			
					$row = $db->nextObject($result);
					
					/* Suppression Pert */
					$query = "DELETE FROM Pert ".
								"WHERE id_pert=".$row->id_pert;
					$db->execQuery($query);
					/* Suppression tâche */
					$query = "DELETE FROM Tache ".
								"WHERE id_pert=".$row->id_pert;
					$db->execQuery($query);
					
					/* Je sais, c'est impardonable de faire ça !!!! */	
					goto marqueur;		
				}
				
				$message = urlencode("Le diagramme PERT a été enregistré avec succès.");
			}
			else
				$message = urlencode("Le diagramme PERT n'a pas été enregistré.");
			
			/* Redirection */
			header('location:../index.php?message='.$message);
			
		break;
		/*===============*/
		/* Fin save-pert */
		/*===============*/	
		
		
		default:
			die('Commande introuvable');
		break;
	}
	
	/* Destruction de l'instance de connexion */
	unset($db);
?>