-- phpMyAdmin SQL Dump
-- version 3.3.2deb1
-- http://www.phpmyadmin.net
--
-- Serveur: localhost
-- Généré le : Lun 06 Décembre 2010 à 22:04
-- Version du serveur: 5.1.41
-- Version de PHP: 5.3.2-1ubuntu4.5

SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;

--
-- Base de données: `gestion_projet`
--

-- --------------------------------------------------------

--
-- Structure de la table `Cocomo`
--

CREATE TABLE IF NOT EXISTS `Cocomo` (
  `id_cocomo` int(3) NOT NULL AUTO_INCREMENT COMMENT 'clef primaire',
  `type_cocomo` varchar(20) NOT NULL COMMENT 'le type du cocomo',
  `mode_cocomo` varchar(15) NOT NULL COMMENT 'le mode du cocomo',
  `kloc` float(10,2) NOT NULL COMMENT 'le nombre de KLOC',
  `effort` float(10,2) NOT NULL COMMENT 'l''effort',
  `temps_dev` float(10,2) NOT NULL COMMENT 'le temps de développement',
  `taille_equipe` float(10,2) NOT NULL COMMENT 'la taille de l''équipe',
  PRIMARY KEY (`id_cocomo`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

--
-- Contenu de la table `Cocomo`
--


-- --------------------------------------------------------

--
-- Structure de la table `FacteursCocomo`
--

CREATE TABLE IF NOT EXISTS `FacteursCocomo` (
  `id_facteurscocomo` int(3) NOT NULL AUTO_INCREMENT COMMENT 'clef primaire',
  `type_cocomo` varchar(15) NOT NULL COMMENT 'Indique s''il s''agit d''un cocomo de base ou intermédiaire',
  `type_calcul` varchar(20) NOT NULL COMMENT 'Indique s''il s''agit d''un calcul de l''effort ou du temps de développement',
  `mode_cocomo` varchar(15) NOT NULL COMMENT 'Indique le mode utilisé (organique, semi-détaché ou embarqué)',
  `a` float(5,2) NOT NULL COMMENT 'Valeur du facteur A',
  `b` float(5,2) NOT NULL COMMENT 'Valeur du facteur B',
  PRIMARY KEY (`id_facteurscocomo`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=13 ;

--
-- Contenu de la table `FacteursCocomo`
--

INSERT INTO `FacteursCocomo` (`id_facteurscocomo`, `type_cocomo`, `type_calcul`, `mode_cocomo`, `a`, `b`) VALUES
(1, 'base', 'effort', 'organique', 2.40, 1.05),
(2, 'base', 'effort', 'semi-détaché', 3.00, 1.12),
(3, 'base', 'effort', 'embarqué', 3.60, 1.20),
(4, 'intermédiaire', 'effort', 'organique', 3.20, 1.05),
(5, 'intermédiaire', 'effort', 'semi-détaché', 3.00, 1.12),
(6, 'intermédiaire', 'effort', 'embarqué', 2.80, 1.20),
(7, 'base', 'temps développement', 'organique', 2.50, 0.38),
(8, 'base', 'temps développement', 'semi-détaché', 2.50, 0.35),
(9, 'base', 'temps développement', 'embarqué', 2.50, 0.32),
(10, 'intermédiaire', 'temps développement', 'organique', 2.50, 0.38),
(11, 'intermédiaire', 'temps développement', 'semi-détaché', 2.50, 0.35),
(12, 'intermédiaire', 'temps développement', 'embarqué', 2.50, 0.32);

-- --------------------------------------------------------

--
-- Structure de la table `Pert`
--

CREATE TABLE IF NOT EXISTS `Pert` (
  `id_pert` int(3) NOT NULL AUTO_INCREMENT COMMENT 'clef primaire',
  `libelle_pert` varchar(30) NOT NULL COMMENT 'le nom du diagramme Pert',
  `id_tache` int(3) NOT NULL COMMENT 'la tache associée',
  KEY `id_tache` (`id_tache`),
  KEY `id_pert` (`id_pert`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=3 ;

--
-- Contenu de la table `Pert`
--


-- --------------------------------------------------------

--
-- Structure de la table `Pointsfonction`
--

CREATE TABLE IF NOT EXISTS `Pointsfonction` (
  `id_pointsfonction` int(3) NOT NULL AUTO_INCREMENT COMMENT 'clef primaire',
  `UFC` int(10) NOT NULL COMMENT 'le nombre d''UFC',
  `TCF` int(10) NOT NULL COMMENT 'le nombre de TCF',
  `PF` int(10) NOT NULL COMMENT 'Le nombre de PF',
  `LOC` int(10) NOT NULL COMMENT 'ne nombre de LOC',
  PRIMARY KEY (`id_pointsfonction`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

--
-- Contenu de la table `Pointsfonction`
--


-- --------------------------------------------------------

--
-- Structure de la table `Projet`
--

CREATE TABLE IF NOT EXISTS `Projet` (
  `id_projet` int(3) NOT NULL AUTO_INCREMENT COMMENT 'clef primaire',
  `libelle_projet` varchar(25) CHARACTER SET utf8 NOT NULL COMMENT 'le libellé du projet',
  `id_cocomo` int(3) NOT NULL COMMENT 'l''identifiant du cocomo',
  `id_pert` int(3) NOT NULL COMMENT 'l''identifiant du diagramme pert',
  `id_pointsfonction` int(3) NOT NULL COMMENT 'l''identifiant des points de fonction',
  PRIMARY KEY (`id_projet`),
  KEY `id_cocomo` (`id_cocomo`),
  KEY `id_pointsfonction` (`id_pointsfonction`),
  KEY `id_pert` (`id_pert`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=5 ;

--
-- Contenu de la table `Projet`
--


-- --------------------------------------------------------

--
-- Structure de la table `Tache`
--

CREATE TABLE IF NOT EXISTS `Tache` (
  `id_tache` int(3) NOT NULL AUTO_INCREMENT COMMENT 'Clef primaire',
  `lettre_tache` varchar(2) NOT NULL COMMENT 'La lettre assimilée à la tâche (A, B, ...)',
  `libelle_tache` varchar(50) NOT NULL COMMENT 'Le libellé de la tâche',
  `duree` int(5) NOT NULL COMMENT 'Le nombre de jours occupé par la tâche',
  `datePlusTot` int(5) NOT NULL COMMENT 'La date de début au plus tôt',
  `datePlusTard` int(5) NOT NULL COMMENT 'La date de début au plus tard',
  `finPlusTot` int(5) NOT NULL COMMENT 'La date de fin au plus tôt',
  `finPlusTard` int(5) NOT NULL COMMENT 'La date de fin au plus tard',
  `marge` int(5) NOT NULL COMMENT 'La marge',
  `predecesseur` varchar(100) NOT NULL COMMENT 'L''identifiant des prédécesseurs',
  `id_pert` int(3) NOT NULL COMMENT 'Clef étrangère',
  PRIMARY KEY (`id_tache`),
  KEY `id_pert` (`id_pert`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=5 ;

--
-- Contenu de la table `Tache`
--

