<?php
	include("header.php");
?>

<script type="text/javascript" src="./js/functions.js"></script>

<div id="content">
	<div id="content-left">
		<div id="pkglist-search">
			<div id="intro" class="box">
				<h2>Méthode des points de fonction</h2>
				<h4>Rappel :</h4>
				<p>Le Point de Fonction mesure la taille d'un logiciel en quantifiant les fonctionnalités offertes aux utilisateurs, en se basant
				seulement sur la modélisation logique et les spécifications fonctionnelles. Dans ce cadre, les principaux objectifs de la mesure PF
				sont les suivants :
					<ul>
						<li>mesurer les fonctionnalités demandées et obtenues par les utilisateurs,</li>
						<li>mesurer la taille des logiciels produits et du parc applicatif, indépendamment des technologies mises en œuvre pour leur implémentation,</li>
						<li>mesurer la productivité des activités de développement et de maintenance logicielle,</li>
						<li>fournir une mesure normalisée, valable pour tous projets et organisations.</li>
					</ul>
					Cette métrique informatique est standardisée par l'organisme international IFPUG (International Function Point User's Group), et normalisée par l'ISO. Elle est très utile pour
					le pilotage des coûts d'une direction informatique, notamment lorsque le recours à la sous-traitance est significatif.
				</p>
			</div>
		</div>
		
		<form name="complexite">
		
		<table class="results tableauGauche">
		<caption><h4>Tableau des compléxités</h4></caption>
			<?php
				$param = 'type="text" size="8" maxlength="8" ';
			?>	
			<tr>
				<td></td>
				<td>Complexité Simple</td>
				<td>Complexité Moyenne</td>
				<td>Complexité Elevée</td>
			</tr>
			<tr>
				<td>Nombre d'Entrées</td>
				<td><input <?php echo $param; ?>/></td>
				<td><input <?php echo $param; ?>/></td>
				<td><input <?php echo $param; ?>/></td>
			</tr>
			<tr>
				<td>Nombre de Sorties</td>
				<td><input <?php echo $param; ?>/></td>
				<td><input <?php echo $param; ?>/></td>
				<td><input <?php echo $param; ?>/></td>
			</tr>
			<tr>
				<td>Nombre d'Interactions</td>
				<td><input <?php echo $param; ?>/></td>
				<td><input <?php echo $param; ?>/></td>
				<td><input <?php echo $param; ?>/></td>
		</tr>
			<tr>
				<td>Nombre de Fichiers internes</td>
				<td><input <?php echo $param; ?>/></td>
				<td><input <?php echo $param; ?>/></td>
				<td><input <?php echo $param; ?>/></td>
			</tr>
			<tr>
				<td>Nombre de Fichiers externes (ou interface)</td>
				<td><input <?php echo $param; ?>/></td>
				<td><input <?php echo $param; ?>/></td>
				<td><input <?php echo $param; ?>/></td>
			</tr>
		</table>
		
		</form><form name="couts">
		
		<table class="results tableauDroit">
			<caption><h4>Facteurs de coûts</h4></caption>
			<tr>
				<td>Télécommunication</td>
				<td><input <?php echo $param; ?>/></td>
			</tr>
			<tr>
				<td>Traitement distribué</td>
				<td><input <?php echo $param; ?>/></td>
			</tr>
			<tr>
				<td>Performance requise</td>
				<td><input <?php echo $param; ?>/></td>
			</tr>
			<tr>
				<td>Configuration saturée</td>
				<td><input <?php echo $param; ?>/></td>
			</tr>
			<tr>
				<td>Taux de transaction</td>
				<td><input <?php echo $param; ?>/></td>
			</tr>
			<tr>
				<td>Saisie interactive</td>
				<td><input <?php echo $param; ?>/></td>
			</tr>
			<tr>
				<td>Efficacité utilisateur</td>
				<td><input <?php echo $param; ?>/></td>
			</tr>
			<tr>
				<td>Mise-à-jour intéractive</td>
				<td><input <?php echo $param; ?>/></td>
			</tr>
			<tr>
				<td>Traitement complexe</td>
				<td><input <?php echo $param; ?>/></td>
			</tr>
			<tr>
				<td>Réutilisabilité</td>
				<td><input <?php echo $param; ?>/></td>
			</tr>
			<tr>
				<td>Facilité d'installation</td>
				<td><input <?php echo $param; ?>/></td>
			</tr>
			<tr>
				<td>Facilité d'exploitation</td>
				<td><input <?php echo $param; ?>/></td>
			</tr>
			<tr>
				<td>Plusieurs sites</td>
				<td><input <?php echo $param; ?>/></td>
			</tr>
			<tr>
				<td>Configurable</td>
				<td><input <?php echo $param; ?>/></td>
			</tr>
		</table>
		
		</form><form name="entree">
		
		<table class="results tableauGauche">
		<caption><h4>Tableau des entrées</h4></caption>
			<tr>
				<td></td>
				<td>Entrée Simple</td>
				<td>Entrée Moyenne</td>
				<td>Entrée Elevée</td>
			</tr>
			<tr>
				<td>Nombre d'Entrées</td>
				<td><input <?php echo $param; ?>/></td>
				<td><input <?php echo $param; ?>/></td>
				<td><input <?php echo $param; ?>/></td>
			</tr>
			<tr>
				<td>Nombre de Sorties</td>
				<td><input <?php echo $param; ?>/></td>
				<td><input <?php echo $param; ?>/></td>
				<td><input <?php echo $param; ?>/></td>
			</tr>
			<tr>
				<td>Nombre d'Interactions</td>
				<td><input <?php echo $param; ?>/></td>
				<td><input <?php echo $param; ?>/></td>
				<td><input <?php echo $param; ?>/></td>
		</tr>
			<tr>
				<td>Nombre de Fichiers internes</td>
				<td><input <?php echo $param; ?>/></td>
				<td><input <?php echo $param; ?>/></td>
				<td><input <?php echo $param; ?>/></td>
			</tr>
			<tr>
				<td>Nombre de Fichiers externes (ou interfaces)</td>
				<td><input <?php echo $param; ?>/></td>
				<td><input <?php echo $param; ?>/></td>
				<td><input <?php echo $param; ?>/></td>
			</tr>
		</table>
		
		</form><form name="equivalence">
		
		<table class="results tableauGauche">
			<caption><h4>Tableau des équivalences</h4></caption>
				<tr>
					<td></td>
					<td>Nombre de lignes de code correspondantes</td>
				</tr>
				<tr>
					<td>Nombre d'Entrées</td>
					<td><input <?php echo $param; ?>/></td>
				</tr>
				<tr>
					<td>Nombre de Sorties</td>
					<td><input <?php echo $param; ?>/></td>
				</tr>
				<tr>
					<td>Nombre d'Interactions</td>
					<td><input <?php echo $param; ?>/></td>
				</tr>
				<tr>
					<td>Nombre de Fichiers internes</td>
					<td><input <?php echo $param; ?>/></td>
				</tr>
				<tr>
					<td>Nombre de Fichiers externes (ou interfaces)</td>
					<td><input <?php echo $param; ?>/></td>
				</tr>
		</table>
	
		</form>
	
		<div style="clear:both" id="pkglist-search">
			<br/>
			<h3>Résultats</h3>
			<table class="results" style="width:300px;">
				<tr class="odd">
					<td><label>UFC</label></td>
					<td><label id="UFC"></label></td>
				</tr>
				<tr class="even">
					<td><label>TCF</label></td>
					<td><label id="TCF"></label></td>
				</tr>
				<tr class="odd">
					<td><label>PF</label></td>
					<td><label id="PF"></label></td>
				</tr>
				<tr class="even">
					<td><label>LOC</label></td>
					<td><label id="LOC"></label></td>
				</tr>
				<tr>
					<td><button onClick="javascript:calculerPointsFonction(document.complexite, document.couts, document.entree, document.equivalence)">Calculer</button></td>
					<td><span id="submit"></span></td>
				</tr>
			</table>
		</div>
		
		<form name="resultat" method="POST" action="./metier/metier.php?action=points-fonction">
			<input name="UFC" type="hidden" />
			<input name="TCF" type="hidden" />
			<input name="PF" type="hidden" />
			<input name="LOC" type="hidden" />
		</form>
	</div>
	
	<?php include("rightmenu.php"); ?>	
	
</div>

<?php
	include("footer.php");
?>